#!/bin/sh

# To/Die/For =)
unset TO_DIE
die() {
    RED='\033[0;31m'
    NC='\033[0m' # No Color
    echo -e "${RED}$1${NC}"
    TO_DIE=1
}
##########################################################################################################################

test -z "${CI_REGISTRY}" && die "CI_REGISTRY is missing"
test -z "${CI_REGISTRY_USER}" && die "CI_REGISTRY_USER is missing"
test -z "${CI_REGISTRY_PASSWORD}" && die "CI_REGISTRY_PASSWORD is missing"
test -z "${CI_PROJECT_PATH}" && die "CI_PROJECT_PATH is missing"
test -z "${REGISTRY_TAG_OLD}" && die "REGISTRY_TAG_OLD is missing"

test -z "${CUSTOM_IMAGENAME}" && IMAGE_PATH="${CI_PROJECT_PATH}" || IMAGE_PATH="${CI_PROJECT_PATH}/${CUSTOM_IMAGENAME}"
test -z "${REGISTRY_TAG_NEW}" && REGISTRY_TAG_NEW=latest

##########################################################################################################################
test -n "${TO_DIE}" && exit 1
##########################################################################################################################

CONTENT_TYPE="application/vnd.docker.distribution.manifest.v2+json"

TOKEN="$(curl --user "${CI_REGISTRY_USER}:${CI_REGISTRY_PASSWORD}" "${SERVER_HOST_SCHEMA:-https}://${CI_SERVER_HOST}/jwt/auth?offline_token=true&service=container_registry&scope=repository:${CI_PROJECT_PATH}:push,pull" | jq -r .token)"

RESULT="$(curl -H "${CONTENT_TYPE}" -H "Authorization: Bearer ${TOKEN}" "${REGISTRY_SCHEMA:-https}://${CI_REGISTRY}/v2/${IMAGE_PATH}/manifests/${REGISTRY_TAG_OLD}")"

##########################################################################################################################

test -z "$(echo ${RESULT} | jq -r .mediaType)" && die "Manifest is missing"
test -n "$(echo ${RESULT} | jq -r .errors[])" && die "Errors are present"

##########################################################################################################################
test -n "${TO_DIE}" && exit 1
